{-# LANGUAGE TypeFamilies #-}
module Numeric.LAPACK.Matrix.Special (
   Matrix.Matrix(Scale,Inverse), Scale, Inverse, inverse,
   ) where

import qualified Numeric.LAPACK.Matrix.Inverse as Inverse
import qualified Numeric.LAPACK.Matrix.Type.Private as Matrix
import qualified Numeric.LAPACK.Matrix.Shape.Omni as Omni
import Numeric.LAPACK.Matrix.Layout.Private (Empty, Filled)


type Scale sh = Matrix.Quadratic Matrix.Scale () () Empty Empty sh
type Inverse typ lower upper sh =
      Matrix.Quadratic (Inverse.Inverse typ) lower upper Filled Filled sh

inverse ::
   (Omni.PowerStrip lower, Omni.PowerStrip upper) =>
   Matrix.QuadraticMeas typ xl xu upper lower meas width height a ->
   Matrix.QuadraticMeas (Inverse.Inverse typ) (xl,lower) (xu,upper)
      lower upper meas height width a
inverse a = Inverse.Inverse a
